
 
#define fragmentshader
#define chunkf

 
#include "ShaderConstants.fxh"
#include "util.fxh"
#include "chunk.yss"
                          
                                                   
struct PS_Input
{
	
    float3 worldpos : WPOS;
	float3 chunkpos : POSIT;
	float4 position : SV_Position;
   

#ifndef BYPASS_PIXEL_SHADER
	lpfloat4 color : COLOR;
	snorm float2 uv0 : TEXCOORD_0_FB_MSAA;
	snorm float2 uv1 : TEXCOORD_1_FB_MSAA;
#endif

#ifdef FOG
	float4 fogColor : FOG_COLOR;
#endif
};

struct PS_Output
{
	float4 color : SV_Target;
};




bool Detection(float2 uv){

float4 texture0 = TEXTURE_0.SampleLevel(TextureSampler0, uvP(uv,0),0.0);
float4 texture1 = TEXTURE_0.SampleLevel(TextureSampler0, uvP(uv,1),0.0);
float4 texture2 = TEXTURE_0.SampleLevel(TextureSampler0, uvP(uv,2),0.0);
float4 texture3 = TEXTURE_0.SampleLevel(TextureSampler0, uvP(uv,3),0.0);


return DETECTION_MODE;
}



 
float4 TEXC(float2 uv){
return TEXTURE_0.Sample(TextureSampler0, uv);
}


float heightmap(float3 color){
return length(color);
}

float3 gettexturenormal(float2 uv,float delta,float H,float f){
	float4 T1 = TEXC(uv);
	float4 T2 = TEXC(float2(uv.x,uv.y+delta));
	float4 T3 = TEXC(float2(uv.x+delta,uv.y));
	float3 point1 = float3(uv.x,heightmap(T1.rgb)*H,uv.y);
	float3 point2 = float3(uv.x,heightmap(T2.rgb)*H,uv.y+delta);
	float3 point3 = float3(uv.x+delta,heightmap(T3.rgb)*H,uv.y);
	return normalize(cross(point2-point1,point3-point1));
}


#define dirx (normalize(dir.x)*RESOLVING_POWER)/TEXTURE_DIMENSIONS.x
#define diry (normalize(dir.y)*RESOLVING_POWER)/TEXTURE_DIMENSIONS.y



float Parallaxsample(float2 uv,float2 dir){

if(!Detection(uv)){

if(Detection(uv-float2(dirx,diry))){
uv.xy-=float2(dirx,diry);}
else if(Detection(uv-float2(dirx,0.0))){
uv.xy-=float2(dirx,0.0);}
else if(Detection(uv-float2(0.0,diry))){
uv.xy-=float2(0.0,diry);}
}

if(TEXTURE_0.SampleLevel(TextureSampler0,uvP(uv,2),0.0).a>0.1/255.0){
return TEXTURE_0.SampleLevel(TextureSampler0,uvP(uv,2),0.0).a*PARALLAX_DEEP+(1.0-PARALLAX_DEEP);
}else{return 1.0;}

}



ROOT_SIGNATURE
void main(in PS_Input PSInput, out PS_Output PSOutput)
{

      
//传统检测
bool WATER = PSInput.color.b*2.0>PSInput.color.r+PSInput.color.g&&PSInput.color.a!=0.0;
bool LEAVES = PSInput.color.a==0.0;


//时间检测部分
float4 light =TEXTURE_1.Sample(TextureSampler1, float2(0.0,1.0)); 

#if TIME_CHECK_TYPE == 0
float timeuv1=smoothstep(0.462745,0.989235,light.r)*2.0-1.0;
#elif TIME_CHECK_TYPE == 1
float timeuv1 = fogtime(FOG_COLOR);
#endif


float3 sunposition=SP(timeuv1);




float3x3 TBNmat = pe(PSInput.worldpos,float3(PSInput.uv0.x,0.0,PSInput.uv0.y));




//纬度检测
bool HELL = FOG_COLOR.b<FOG_COLOR.r&&FOG_COLOR.b<0.05&&FOG_COLOR.r<0.5;
//bool UWATER = (FOG_COLOR.b>0.15&&(FOG_COLOR.b>FOG_COLOR.g*1.2)&&(FOG_COLOR.b>=FOG_COLOR.r*1.8)&&(FOG_COLOR.g>FOG_COLOR.r*1.6))||(FOG_COLOR.g*1.2>=FOG_COLOR.b)&&(FOG_COLOR.r*1.3<FOG_COLOR.g);
bool UWATER = FOG_CONTROL.y<0.17;

float shadowmap=1.0;



#define ax (normalize(uvdir.x)*RESOLVING_POWER)/TEXTURE_DIMENSIONS.x
#define ay (normalize(uvdir.y)*RESOLVING_POWER)/TEXTURE_DIMENSIONS.y

#define sx (normalize(sunuvw0p.x)*RESOLVING_POWER)/TEXTURE_DIMENSIONS.x
#define sy (normalize(sunuvw0p.y)*RESOLVING_POWER)/TEXTURE_DIMENSIONS.y

#define bx RESOLVING_POWER/TEXTURE_DIMENSIONS.x
#define by RESOLVING_POWER/TEXTURE_DIMENSIONS.y



#ifdef FOUR_IN_ONE_PBRTEX
#ifdef PARALLAX

float3 uvw0 = float3(PSInput.uv0,0.0); 
//视线
float3 uvw0p = normalize(WToP(normalize(PSInput.worldpos),TBNmat));
uvw0p/=-uvw0p.z;
float2 uvdir = uvw0p.xy;
uvw0p.xy/=TEXTURE_DIMENSIONS.xy/RESOLVING_POWER;





if(length(PSInput.worldpos)<PARALLAX_DISTANCE){

float nu = 1.0;
int b = 0;
float3 beuvw=uvw0;

if(Detection(PSInput.uv0)){


while(1.0+uvw0.z>Parallaxsample(uvw0.xy,uvw0p.xy)&&b<100){
beuvw=uvw0;
uvw0+=uvw0p*PARALLAX_STEP_LENGTH;
b+=1;
}
//视差步进

int o=0;
while(o<PARALLAX_SAMPLE_NUM){
if(1.0+((uvw0+beuvw)/2.0).z<Parallaxsample(((uvw0+beuvw)/2.0).xy,uvw0p.xy)){uvw0=(uvw0+beuvw)/2.0;}
else{beuvw=(uvw0+beuvw)/2.0;}
o+=1;
}
//二分搜索

if(!Detection(uvw0.xy)){
if(Detection(uvw0.xy-float2(ax,ay))){
uvw0.xy-=float2(ax,ay);}
else if(Detection(uvw0.xy-float2(0.0,ay))){
uvw0.xy-=float2(0.0,ay);}
else if(Detection(uvw0.xy-float2(ax,0.0))){
uvw0.xy-=float2(ax,0.0);}
}
//uv偏移



}

PSInput.uv0=uvw0.xy;



}



#endif
#endif



//留着写视差
 


#ifdef BYPASS_PIXEL_SHADER
    PSOutput.color = float4(0.0f, 0.0f, 0.0f, 0.0f);
    return;
#else

float4 diffuse = TEXTURE_0.SampleLevel(TextureSampler0,PSInput.uv0,0.0);
                      

#ifdef SEASONS_FAR
	diffuse.a = 1.0f;
#endif

#if USE_ALPHA_TEST
	#ifdef ALPHA_TO_COVERAGE
		#define ALPHA_THRESHOLD 0.05
	#else
		#define ALPHA_THRESHOLD 0.5
	#endif
	if(diffuse.a < ALPHA_THRESHOLD)
		discard;
#endif
 
#if defined(BLEND)
	diffuse.a *= PSInput.color.a;
#endif
                
#if !defined(ALWAYS_LIT)
	//diffuse = diffuse * TEXTURE_1.Sample(TextureSampler1, PSInput.uv1);
#endif
 
#ifndef SEASONS
	#if !USE_ALPHA_TEST && !defined(BLEND)
		diffuse.a = PSInput.color.a;
	#endif	



float3 inco = 1.0;


if(PSInput.color.g!=PSInput.color.r){
if(PSInput.color.a==0.0){inco.rgb = normalize(PSInput.color.rgb)*0.8;}
else if(PSInput.color.g*2.0>PSInput.color.r+PSInput.color.b){inco.rgb= 0.9*normalize(PSInput.color.rgb);}
else{inco.rgb=PSInput.color.rgb;}}



float3 ao =PSInput.color.rgb/inco;
if(PSInput.color.b*2.0>PSInput.color.r+PSInput.color.g)ao=1.0;
diffuse.rgb*=inco;


if(PSInput.color.a==0.0){
	diffuse.rgb*=0.8;
	diffuse.rgb=saturation(diffuse.rgb,0.7);
	diffuse.rgb*=1.7;
}



  
//colormap
 
#else
	float2 uv = PSInput.color.xy;
	diffuse.rgb *= lerp(1.0f, TEXTURE_2.Sample(TextureSampler2, uv).rgb*2.0f, PSInput.color.b);
	diffuse.rgb *= PSInput.color.aaa;
	diffuse.a = 1.0f;
#endif

                         
float4 textbasic =TEXTURE_0.SampleLevel(TextureSampler0, PSInput.uv0,0.0);
float4 text=float4(diffuse.rgb,textbasic.a);
  


//检测部分（金属和玻璃为传统）

bool MAT = text.a>0.977&&text.a<0.982&&PSInput.color.a!=0.0;
bool GLASS = text.a<0.5&&text.a>0.05;
bool LAMP = text.a>0.987&&text.a<0.992&&PSInput.color.a!=0.0;




//法线参数获取
float3 normal = -normalize(cross(ddx(PSInput.worldpos),ddy(PSInput.worldpos)));
float3 overallnormal=normal;


//粗糙度金属度自发光参数获取 

float3 BF = 0.08;
float3 albedo = text.rgb;
float roughness = 1.0;
float metallic = 0.0;
float shinemap = 0.0;



if(WATER){
BF = 0.4;
roughness = 0.0;                       
metallic = 0.0; 
shinemap = 0.0; 

#ifdef NORMALTYPE
float3 nw = float3(0.0,1.0,0.0);

#if NORMALTYPE==1 
nw=getnormal(PSInput.chunkpos.xyz,0.2);
#elif NORMALTYPE==2
nw=normalize(TEXTURE_0.Sample(TextureSampler0,PSInput.uv0)*2.0-1.0);
#elif NORMALTYPE==3
nw=gettexturenormal(PSInput.uv0,vec2(NORMAL_DELTA)/TEXTURE_DIMENSIONS.xy,NORMAL_DEEP);
#endif

normal = PToW(nw.rbg,TBNmat);
#endif
 
}
 
else
{
#ifdef FOUR_IN_ONE_PBRTEX

float4 TEX0= TEXTURE_0.SampleLevel(TextureSampler0,uvP(PSInput.uv0,0),0.0);
float4 TEX1= TEXTURE_0.SampleLevel(TextureSampler0,uvP(PSInput.uv0,1),0.0);
float4 TEX2= TEXTURE_0.SampleLevel(TextureSampler0,uvP(PSInput.uv0,2),0.0);
float4 TEX3= TEXTURE_0.SampleLevel(TextureSampler0,uvP(PSInput.uv0,3),0.0);
 
  
if(Detection(PSInput.uv0)){


#ifdef PBRMAP
if(TEX1.a>0.05){
roughness = RN;
metallic = ML;
shinemap = SM;
ao*=AM;
}
#endif

  
#ifdef NORNALMAP

//法线贴图
float3 NT =(TEX2.rbg*2.0-float3(1.0,1.0,1.0));
normal = PToW(NT.rbg,TBNmat);
//normal=NT;
#endif
     
 
}else{
roughness = 1.0;                                               
metallic = 0.0;
shinemap = 0.0;                     
}

#else  

//alpha pbr
       
#endif      
}

      


//视角参数获取
float3 view = normalize(-PSInput.worldpos);  
normal=normalize(normal);

if(HELL){
#include "render/chunkhell.render"
 }
 else {     

#include "render/chunkbasic.render"
 }
//diffuse.rgb=normal;
//diffuse.rg=float2(roughness,metallic);
//diffuse = TEXTURE_0.SampleLevel(TextureSampler0,uvP(PSInput.uv0,2),0.0);
 
#ifdef FOG
	//diffuse.rgb = lerp( diffuse.rgb, PSInput.fogColor.rgb, PSInput.fogColor.a );
#endif

	PSOutput.color = diffuse;   

#ifdef VR_MODE
	// On Rift, the transition from 0 brightness to the lowest 8 bit value is abrupt, so clamp to 
	// the lowest 8 bit value.
	PSOutput.color = max(PSOutput.color, 1 / 255.0f);
#endif

#endif // BYPASS_PIXEL_SHADER
}  